/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.web.thin;

import java.io.IOException;

import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import jp.terasoluna.fw.web.RequestUtil;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * ANZX̃`FbNsB
 * 
 * <p>
 * ̃NXł̓uEŨNGXgɑ΂tB^A
 * Bean`t@CŎw肳ꂽCӂ{@link AuthorizationController}CX^X
 * ĂяoAw肳ꂽpXւ̃ANZXĂ邩ǂ
 * `FbNϏB
 * </p>
 * 
 * <h5>ANZX`FbN@\</h5>
 * <p>
 * w肳ꂽpXւ̃ANZXĂ邩𔻕ʂB 
 * ANZXᔽ̏ꍇ́A{@link UnauthorizedException}X[B
 * </p>
 * <h5>gp@</h5>
 * <p>
 * ̋@\gpɂ fvCgfBXNv^iweb.xmlj
 * Bean`t@CɈȉ̂悤ɐݒ肷B
 * ̂ƂABean`t@Cɒ`idA
 * sampleAuthorizationControllerł&lt;bean&gt;vf
 * classɂ́A{@link AuthorizationController}C^tF[X
 * NXݒ肷B<br>
 *</p>
 * fvCgfBXNv^iweb.xmlj<pre><code>
 * &lt;filter&gt;
 *   &lt;filter-name&gt;
 *     authorizationControlFilter
 *   &lt;/filter-name&gt;
 *   &lt;filter-class&gt;
 *     jp.terasoluna.fw.web.thin.AuthorizationControlFilter
 *   &lt;/filter-class&gt;
 *   &lt;init-param&gt;
 *     &lt;param-name&gt;controller&lt;/param-name&gt;
 *     &lt;param-value&gt;
 *       "sampleAuthorizationController"
 *     &lt;/param-value&gt;
 *   &lt;/init-param&gt;
 * &lt;/filter&gt;
 *
 * &lt;filter-mapping&gt;
 *   &lt;filter-name&gt;authorizationControlFilter&lt;/filter-name&gt;
 *   &lt;url-pattern&gt;/*&lt;/url-pattern&gt;
 * &lt;/filter-mapping&gt;
 * 
 * &lt;error-page&gt;
 *   &lt;exception-type&gt;
 *     jp.terasoluna.fw.web.thin.UnauthorizedException
 *   &lt;/exception-type&gt;
 *   &lt;location&gt;/unauthorizedError.jsp&lt;/location&gt;
 * &lt;/error-page&gt;
 * </pre></code>
 * 
 * Bean`t@C
 * <pre><code>
 * &lt;bean id=&quot;sampleAuthorizationController&quot;
 *       class=&quot;jp.terasolunacSampleAuthorizationController&quot; /&gt;
 * </code></pre>
 * 
 * ȂABean`t@Cɒ`&lt;bean&gt;vfidftHglł
 * "authorizationController"ɐݒ肷ꍇɂ́A
 * fvCgfBXNv^iweb.xmlj&lt;filter&gt;vf
 * &lt;init-param&gt;vfȗ邱ƂłB
 * 
 * @see jp.terasoluna.fw.web.thin.AuthorizationController
 * @see jp.terasoluna.fw.web.thin.BlockageControlFilter
 * @see jp.terasoluna.fw.web.thin.BlockageController
 * @see jp.terasoluna.fw.web.thin.ServerBlockageControlFilter
 * @see jp.terasoluna.fw.web.thin.ServerBlockageController
 * 
 */
public class AuthorizationControlFilter 
        extends AbstractControlFilter<AuthorizationController> {
    
    /**
     * NGXgtB^ʉ߂ƂNGXg̃L[B
     */
    public static final String AUTHORIZATION_THRU_KEY 
        = "AUTHORIZATION_THRU_KEY";   
    
    /**
     * DIReiRg[[̎NX擾邽߂
     * &lt;bean&gt;vfidɎgpftHgidB
     */
    public static final String DEFAULT_AUTHORIZATION_BEAN_ID
        = "authorizationController";
    
    /**
     * I[\[[VRg[̐sG[R[hB
     */
    private static final String AUTHORIZATION_CONTROLLER_ERROR 
        = "errors.authorization.controller";

    /**
     * ANZX`FbNϏRg[NXB
     */
    private static final Class AUTHORIZATION_CONTROLLER_CLASS 
        = AuthorizationController.class;
   
    /**
     * ONXB
     */
    private static Log log 
       = LogFactory
           .getLog(AuthorizationControlFilter.class);

    /**
     * AuthorizationControllerCX^XB
     */
    protected static AuthorizationController controller = null;
    

    /**
     * AuthorizationControllerCX^X߂B
     * 
     * @return ̃tB^ɐݒ肳ĂAuthorizationControllerCX^X
     */
    public static AuthorizationController getAuthorizationController() {
        return controller;
    }

    /**
     * tB^T[rXJnԂɂȂۂɁAReiɂČĂяoB 
     * 
     * ReíAFilterCX^XɁAinit\bh
     * 1 񂾂ĂяoB<br>
     * FilterɃtB^Ƃs悤ɗvɂ́A
     * init \bh IĂȂ΂ȂȂB
     * init\bh ̂ꂩ̏Ԃ̏ꍇARei
     * FilterT[rXԂɂłȂB<br>
     * <ul>
     *  <li>ServletException X[B</li>
     *  <li>ReiɂĒ`ꂽԓɁAAȂB</li>
     *  <li>ݒ肳ꂽRg[̎NX݂ȂA 
     *      ܂͐ݒُ펞B</li>
     * </ul>
     * 
     * @param config FilterConfigCX^XB
     * 
     * @throws javax.servlet.ServletException ُ펞ɃX[OB
     *             
     * @see javax.servlet.Filter#init(javax.servlet.FilterConfig)
     * @see jp.terasoluna.fw.web.thin.AbstractControlFilter
     */
    @Override
    public void init(FilterConfig config) throws ServletException {
        super.init(config);
        if (controller == null) {
            controller = getController();
        }
    }
    
    /**
     * ANZX`FbNsB
     * 
     * @param req HTTPNGXg
     * @param res HTTPX|X
     * @param chain tB^`F[
     * 
     * @throws IOException I/OG[
     * @throws ServletException T[ubgO
     * 
     * @see javax.servlet.Filter#doFilter(javax.servlet.ServletRequest, 
     *                                    javax.servlet.ServletResponse,
     *                                    javax.servlet.FilterChain)
     */
    @Override
    public void doFilter(ServletRequest req, 
                         ServletResponse res,
                         FilterChain chain) 
            throws IOException, 
                   ServletException {

        // NGXgtB^ʉ߂ǂ𔻒B
        if (req.getAttribute(AUTHORIZATION_THRU_KEY) == null) {

            // tB^̒ʉߏZbg
            req.setAttribute(AUTHORIZATION_THRU_KEY, "true");

            // ʋƖɈڂǂpX`FbNB
            if (controller.isCheckRequired(req)) {

                // ANZX`FbN
                if (!controller
                    .isAuthorized(RequestUtil.getPathInfo(req), req)) {
                    if (log.isDebugEnabled()) {
                        log.debug("isAuthorized() failed.");
                    }
                    throw new UnauthorizedException();
                }
            }
        }

        // ̃tB^܂̓T[ubg
        chain.doFilter(req, res);
    }
    
    /**
     * ANZXsNXׂC^tF[XԂB
     * 
     * @return ̃tB^ŎgpRg[̃NX
     */
    @Override
    protected Class getControllerClass() {
        return AUTHORIZATION_CONTROLLER_CLASS;
    }

    /**
     * Rg[̐sG[R[hԂB
     * 
     * @return G[R[h
     */
    @Override
    protected String getErrorCode() {
        return AUTHORIZATION_CONTROLLER_ERROR;
    }

    /**
     * DIReiRg[擾ۂ̃ftHgidԂB
     * 
     * @return ftHgidl
     */
    @Override
    public String getDefaultControllerBeanId() {
        return DEFAULT_AUTHORIZATION_BEAN_ID;
    }
    
}
